package com.poo.agusa.usmroute;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import java.io.InputStream;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class Main extends AppCompatActivity {

    private Spinner mainsp;
    private EditText et1;
    private Ruta ruta_actual;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        et1 = findViewById(R.id.editText);
        mainsp = findViewById(R.id.spinner);

        String [] opt = {"Avenida España", "Calle Valdés", "Avenida Placeres, porteria Placeres" , "Avenida Placeres, entrada edificio P"};
        ArrayAdapter<String> adpt = new ArrayAdapter<>(this, android.R.layout.simple_spinner_dropdown_item,opt);
        mainsp.setAdapter(adpt);

        //Lectura de datos del archivo.
        InputStream a_nodos = getResources().openRawResource(R.raw.nodos);
        InputStream a_rutas = getResources().openRawResource(R.raw.rutas);

        ruta_actual = new Ruta(a_nodos, a_rutas);
    }

    public static int getResId(String resName, Class<?> c) {

        try {
            Field idField = c.getDeclaredField(resName);
            return idField.getInt(idField);
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }

    public static String siguienteLayout(String idName) {
        if(idName.equals("NodoT_NodoTL"))
            return ".activity_mapa_p0";
        if(idName.equals("NodoTL_NodoP1"))
            return ".mapa_p1";
        if(idName.equals("NodoP1_NodoP11"))
            return ".mapa_p1";
        if(idName.equals("NodoT_NodoP0"))
            return ".activity_mapa_p0";
        //Agregar de acuerdo a los que falten.
        return null;
    }

    public void button_action(View view){
        String classroom = et1.getText().toString();
        if(TextUtils.isEmpty(classroom)){
            et1.setError("¡No ha ingresado la sala!");
            return;
        }
        if(!ruta_actual.existeNodo(classroom))
        {
            Toast.makeText(this, "Sala no existe en registros", Toast.LENGTH_LONG).show();
            return;
        }

        Spinner mySpinner = (Spinner) findViewById(R.id.spinner);
        String start_at = mySpinner.getSelectedItem().toString();
        if(start_at.equals("Avenida España"))
            start_at = "NodoI";
        else if(start_at.equals("Avenida Placeres, porteria Placeres"))
            start_at = "NodoJ";
        else if(start_at.equals("Avenida Placeres, entrada edificio P"))
            start_at = "NodoP1";
        else
        {
            Toast.makeText(this, "Nodo inicial aun no se encuentra en los registros", Toast.LENGTH_LONG).show();
            return;
        }

        LinkedList<Vertex> caminos = ruta_actual.obtenerRuta(start_at,classroom);
        if(caminos == null)
        {
            Toast.makeText(this, "No se encontro ruta.", Toast.LENGTH_LONG).show();
            return;
        }

        char c = classroom.charAt(0);
        char level = classroom.charAt(1);
        char aisle = classroom.charAt(2);
        char room = classroom.charAt(3);
        if (c != 'c' && c != 'C' && c != 'p' && c != 'P'){ //Si la sala no se encuentra en los registros o la sala tiene mas de 4 caracteres
            Toast.makeText(this, "Sala no existe en los registros", Toast.LENGTH_LONG).show();
        }
        else if(classroom.length() != 4){
            Toast.makeText(this, "El formato de la sala debe ser de 4 caracteres! (ej: P313)",Toast.LENGTH_LONG).show();
        }
        else {
            if (c == 'c' || c == 'C') {
                Toast.makeText(this, "Vas al edificio C", Toast.LENGTH_LONG).show();
            } else {
                Toast.makeText(this, "Vas al edificio P", Toast.LENGTH_LONG).show();
            }

            startActivity(new Intent(Main.this, Mapa_general.class));
        }
    }
}